unit robot1;

// Auteur : Alain Weber
// Date AAAAMMJJ : 20200417
// email : alpweber@hotmail.com
// libre de copie en conservant les informations sur l'auteur
// Compil avec Delphi XE10

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Classes,
  System.Variants, FMX.Types, FMX.Controls, FMX.Forms, FMX.Graphics, FMX.Dialogs, FMX.StdCtrls,
  FMX.TreeView, FMX.Layouts, FMX.Types3D, System.Math.Vectors, FMX.Objects3D,
  FMX.Controls3D, FMX.Viewport3D, FMX.MaterialSources, FMX.DAE.Importer,
  FMX.OBJ.Importer, FMX.Controls.Presentation, FMX.Edit,
  FMX.EditBox, FMX.NumberBox, FMX.TabControl, FMX.SpinBox, System.Math,
  FMX.ListBox, FMX.Memo, FMX.Ani, FMX.ScrollBox, uRotationDeplacementXE10;

type
  TfrmRobot = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Button1: TButton;
    BtSauve: TButton;
    Button2: TButton;
    Memo1: TMemo;
    Button7: TButton;
    ListBox1: TListBox;
    ArcDial2: TArcDial;
    FloatAnimation3: TFloatAnimation;
    ArcDial3: TArcDial;
    FloatAnimation5: TFloatAnimation;
    ArcDial1: TArcDial;
    FloatAnimation2: TFloatAnimation;
    ArcDial4: TArcDial;
    FloatAnimation1: TFloatAnimation;
    ScrollBar2: TScrollBar;
    FloatAnimation4: TFloatAnimation;
    Edit1: TEdit;
    Edit2: TEdit;
    Button3: TButton;
    Button5: TButton;
    Viewport3D1: TViewport3D;
    LightMaterialSource1: TLightMaterialSource;
    DummyBase: TDummy;
    Dummy90: TDummy;
    Dummy1: TDummy;
    StrokeCube1: TStrokeCube;
    Splitter1: TSplitter;
    Cylinder01: TCylinder;
    Dummy02: TDummy;
    Model3D02: TModel3D;
    Dummy03: TDummy;
    Model3D03: TModel3D;
    Dummy04: TDummy;
    Model3D04: TModel3D;
    Dummy05: TDummy;
    Cylinder05: TCylinder;
    Dummy06: TDummy;
    Model3D06: TModel3D;
    Light1: TLight;
    LMS2: TLightMaterialSource;
    LMS3: TLightMaterialSource;
    procedure FormActivate(Sender: TObject);
    procedure ArcDial1Change(Sender: TObject);
    procedure ArcDial2Change(Sender: TObject);
    procedure ArcDial3Change(Sender: TObject);
    procedure ScrollBar2Change(Sender: TObject);
    procedure ArcDial4Change(Sender: TObject);
    procedure BtSauveClick(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure ListBox1DblClick(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    Ctrl3DEnCours: TControl3D;
    DummyEnCours1 : TDummy;
    aRotation3axes: TRotationDeplacement3axes ;
  end;

var
  frmRobot: TfrmRobot;
  bPrem: Boolean = true;

implementation

{$R *.fmx}

procedure TfrmRobot.FormActivate(Sender: TObject);
var
  stNomFic: string;
  i1: Integer;
begin
  if not bPrem then
    exit;
  bPrem := false;
  aRotation3axes := TRotationDeplacement3axes.Create(Dummy1,Viewport3D1);
  aRotation3axes.InitialiseWheelPAram(1, 12, 0);
  // HauteurdeBase1, NbrePas1, Profondeur1
  aRotation3axes.Reset;
  Viewport3D1.OnMouseDown := aRotation3axes.MouseDown;
  Viewport3D1.OnMouseMove := aRotation3axes.MouseMove;
  FormatSettings.DecimalSeparator := '.';
  StrokeCube1.Visible := true;
  for i1 := 0 to Length(Model3D02.MeshCollection) - 1 do
    Model3D02.MeshCollection[i1].MaterialSource := LMS2;
  for i1 := 0 to Length(Model3D03.MeshCollection) - 1 do
    Model3D03.MeshCollection[i1].MaterialSource := LMS2;
  for i1 := 0 to Length(Model3D04.MeshCollection) - 1 do
    Model3D04.MeshCollection[i1].MaterialSource := LMS2;
  for i1 := 0 to Length(Model3D06.MeshCollection) - 1 do
    Model3D06.MeshCollection[i1].MaterialSource := LMS3;
  ScrollBar2.Value := Dummy05.Position.Y;
  ScrollBar2.Max := -0.3;
  ScrollBar2.Min := -0.6;
end;

procedure TfrmRobot.ListBox1DblClick(Sender: TObject);
var
  Sl1: TStringList;
  st1: string;
begin
  st1 := ListBox1.Items[ListBox1.ItemIndex];
  Sl1 := TStringList.Create;
  Sl1.Delimiter := ';';
  Sl1.DelimitedText := st1;
  FloatAnimation1.StartValue := ArcDial4.Value;
  FloatAnimation1.StopValue := Sl1[0].ToSingle;
  FloatAnimation1.Duration := 1.5;
  FloatAnimation2.StartValue := ArcDial1.Value;
  FloatAnimation2.StopValue := Sl1[1].ToSingle;
  FloatAnimation2.Duration := 1.5;
  FloatAnimation3.StartValue := ArcDial2.Value;
  FloatAnimation3.StopValue := Sl1[2].ToSingle;
  FloatAnimation3.Duration := 1.5;
  FloatAnimation4.StartValue := ScrollBar2.Value;
  FloatAnimation4.StopValue := Sl1[3].ToSingle;
  FloatAnimation4.Duration := 1.5;
  FloatAnimation5.StartValue := ArcDial3.Value;
  FloatAnimation5.StopValue := Sl1[4].ToSingle;
  FloatAnimation5.Duration := 1.5;
  Sleep(100);
  FloatAnimation1.Start;
  FloatAnimation2.Start;
  FloatAnimation3.Start;
  FloatAnimation4.Start;
  FloatAnimation5.Start;
end;

procedure TfrmRobot.ScrollBar2Change(Sender: TObject);
begin
  Dummy05.Position.Y := ScrollBar2.Value;
  Edit2.text := ScrollBar2.Value.ToString;
end;

function NomFichier(st1: string): string;
begin
  Result := ExtractFileName(st1);
end;

procedure TfrmRobot.ArcDial1Change(Sender: TObject);
begin
  Dummy03.RotationAngle.X := ArcDial1.Value;
end;

procedure TfrmRobot.ArcDial2Change(Sender: TObject);
begin
  Dummy04.RotationAngle.X := ArcDial2.Value;
end;

procedure TfrmRobot.ArcDial3Change(Sender: TObject);
begin
  Dummy06.RotationAngle.Y := ArcDial3.Value;
end;

procedure TfrmRobot.ArcDial4Change(Sender: TObject);
begin
  Dummy02.RotationAngle.Z := ArcDial4.Value;
end;

procedure TfrmRobot.BtSauveClick(Sender: TObject);
begin
  Memo1.Lines.SaveToFile('Positions.txt');
end;

procedure TfrmRobot.Button1Click(Sender: TObject);
begin //xx
  Memo1.Lines.LoadFromFile('Positions.txt');
end;

procedure TfrmRobot.Button2Click(Sender: TObject);
var
  st1: string;
begin
  st1 := Format('%.0f;%.0f;%.0f;%.3f;%.0f;?', [ArcDial4.Value, ArcDial1.Value,
    ArcDial2.Value, ScrollBar2.Value, ArcDial3.Value]);
  Memo1.Lines.Add(st1);
end;

procedure TfrmRobot.Button5Click(Sender: TObject);
begin
  aRotation3axes.Reset
end;

procedure TfrmRobot.Button7Click(Sender: TObject);
begin
  ListBox1.Items.text := Memo1.Lines.text;
end;

end.
